
// USB5744Dlg.cpp : t@C
//
#include "stdafx.h"

#include <windows.h>
#include <strsafe.h>

#include <setupapi.h>

#include "PT2_DLL.h"

#include "USB5744.h"
#include "USB5744Dlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CUSB5744Dlg _CAO
//Device OPEN/CLOSE
typedef INT (*pfMchpUsbGetAllHubs) (PCHAR);
typedef HANDLE (*pfMchpUsbOpen) (CONST UINT);
typedef BOOL (*pfMchpUsbClose) (HANDLE);



//Miscellaneous
typedef BOOL (*pfMchpUsbGetVersion) (PCHAR );



//Device Open/Close
pfMchpUsbGetAllHubs libMchpUsbGetAllHubs;
pfMchpUsbOpen libMchpUsbOpen;
pfMchpUsbClose libMchpUsbClose;

//Miscellaneous
pfMchpUsbGetVersion libMchpUsbGetVersion;

//GPIO 
typedef BOOL (*pfMchpUsbConfigureGPIO) (HANDLE,INT);
typedef BOOL (*pfMchpUsbGpioSet) (HANDLE, INT, INT);

pfMchpUsbConfigureGPIO libMchpUsbConfigureGPIO;
pfMchpUsbGpioSet libMchpUsbGpioSet;

HANDLE hDevice =  INVALID_HANDLE_VALUE;

CUSB5744Dlg::CUSB5744Dlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CUSB5744Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSB5744Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CUSB5744Dlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, &CUSB5744Dlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON1, &CUSB5744Dlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON3, &CUSB5744Dlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CUSB5744Dlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CUSB5744Dlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CUSB5744Dlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CUSB5744Dlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CUSB5744Dlg::OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON9, &CUSB5744Dlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON11, &CUSB5744Dlg::OnBnClickedButton11)
END_MESSAGE_MAP()


// CUSB5744Dlg bZ[W nh[

BOOL CUSB5744Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CUSB5744Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

HCURSOR CUSB5744Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CUSB5744Dlg::AddText(CString addstr)
{
	LPTSTR str = new TCHAR[addstr.GetLength() + 1];
	_tcscpy_s(str, addstr.GetLength() + 1, addstr);

	SendDlgItemMessage(IDC_EDIT_MSG, EM_SETSEL, 0, -1);
	SendDlgItemMessage(IDC_EDIT_MSG, EM_SETSEL, -1, -1);
	SendDlgItemMessage(IDC_EDIT_MSG, EM_REPLACESEL, 0, (LPARAM)str);
	delete str;

	::RedrawWindow((GetDlgItem(IDC_EDIT_MSG))->m_hWnd, NULL, NULL, RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW);
}

void CUSB5744Dlg::ClearText(void)
{
	((CEdit*)GetDlgItem(IDC_EDIT_MSG))->SetWindowText(_T(""));
	::RedrawWindow((GetDlgItem(IDC_EDIT_MSG))->m_hWnd, NULL, NULL, RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW);
}

void CUSB5744Dlg::OnBnClickedButton2()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(	hDevice !=  INVALID_HANDLE_VALUE){
		if(FALSE == libMchpUsbGpioSet (hDevice,17,1)){//PCTL1 ON
			AddText(_T("PCTL1 ON Failed\n"));
		}else{
			AddText(_T("PCTL1 ON Success\n"));
		}
	}
}


void CUSB5744Dlg::OnBnClickedButton1()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	
	CHAR sztext[2048];
	//CHAR szFilename[256];
	UINT hubindex = 0 ;
	INT iRestartDelay = 10000;

	//Load library
	HMODULE LoadLib = LoadLibrary (_T("pt2lib.dll"));
	if (LoadLib != NULL) 
	{ 
		AddText(_T("Loadlib library Loaded\n"));
	}
	else 
	{
		AddText(_T("Loadlib library Failed\n"));
		return;
	}

	//Device Open/close
	libMchpUsbGetAllHubs		= (pfMchpUsbGetAllHubs) GetProcAddress ( LoadLib ,"MchpUsbGetAllHubs");
	libMchpUsbOpen				= (pfMchpUsbOpen) GetProcAddress ( LoadLib ,"MchpUsbOpen");
	libMchpUsbClose			= (pfMchpUsbClose) GetProcAddress ( LoadLib ,"MchpUsbClose");

	//Miscellaneous
	libMchpUsbGetVersion		= (pfMchpUsbGetVersion) GetProcAddress ( LoadLib ,"MchpUsbGetVersion");

	libMchpUsbConfigureGPIO		=	(pfMchpUsbConfigureGPIO) GetProcAddress ( LoadLib ,"MchpUsbConfigureGPIO");
	libMchpUsbGpioSet			=	(pfMchpUsbGpioSet) GetProcAddress ( LoadLib ,"MchpUsbGpioSet");


	if (FALSE == libMchpUsbGetVersion(sztext))
	{
		AddText(_T("libMchpUsbGetVersion Failed\n"));
		return;
	}

	int hub_count = 0;

	//hub index to process
	UINT HubIndex=0;

	//get all hubs
	hub_count =  libMchpUsbGetAllHubs(sztext);

	// open device
	if(hub_count == 0)
	{
		AddText(_T("libMchpUsbGetAllHubs Failed\n"));
		return;
	}else{
		AddText(_T(sztext));
	}

	hDevice =  INVALID_HANDLE_VALUE;
	hDevice = libMchpUsbOpen(HubIndex);

	if(INVALID_HANDLE_VALUE == hDevice)
	{
		AddText(_T("libMchpUsbOpen Failed\n"));
		return;
	}
	AddText(_T("Device Opened successfully\n"));

	if(FALSE ==libMchpUsbConfigureGPIO(hDevice,17)){//PCTL1
		AddText(_T("libMchpUsbConfigureGPIO pin36 Failed\n"));
	}else{
		if(FALSE == libMchpUsbGpioSet (hDevice,17,1)){//PCTL1 ON
			AddText(_T("libMchpUsbGpioSet pin36 Failed\n"));
		}
	}
	if(FALSE ==libMchpUsbConfigureGPIO(hDevice,18)){//PCTL2
		AddText(_T("libMchpUsbConfigureGPIO pin35 Failed\n"));
	}else{
		if(FALSE == libMchpUsbGpioSet (hDevice,18,1)){//PCTL2 ON
			AddText(_T("libMchpUsbGpioSet pin35 Failed\n"));
		}
	}
	if(FALSE ==libMchpUsbConfigureGPIO(hDevice,19)){//PCTL3
		AddText(_T("libMchpUsbConfigureGPIO pin34 Failed\n"));
	}else{
		if(FALSE == libMchpUsbGpioSet (hDevice,19,1)){//PCTL3 ON
			AddText(_T("libMchpUsbGpioSet pin34 Failed\n"));
		}
	}
	if(FALSE ==libMchpUsbConfigureGPIO(hDevice,20)){//PCTL4
		AddText(_T("libMchpUsbConfigureGPIO pin32 Failed\n"));
	}else{
		if(FALSE == libMchpUsbGpioSet (hDevice,20,1)){//PCTL4 ON
			AddText(_T("libMchpUsbGpioSet pin32 Failed\n"));
		}
	}
	AddText(_T("Device Initialize successfully\n"));
}

void CUSB5744Dlg::OnBnClickedButton3()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(	hDevice !=  INVALID_HANDLE_VALUE){
		if(FALSE == libMchpUsbGpioSet (hDevice,17,0)){//PCTL1 OFF
			AddText(_T("PCTL1 OFF Failed\n"));
		}else{
			AddText(_T("PCTL1 OFF Success\n"));
		}
	}
}


void CUSB5744Dlg::OnBnClickedButton4()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(	hDevice !=  INVALID_HANDLE_VALUE){
		if(FALSE == libMchpUsbGpioSet (hDevice,18,1)){//PCTL2 ON
			AddText(_T("PCTL2 ON Failed\n"));
		}else{
			AddText(_T("PCTL2 ON Success\n"));
		}
	}
}


void CUSB5744Dlg::OnBnClickedButton5()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(	hDevice !=  INVALID_HANDLE_VALUE){
		if(FALSE == libMchpUsbGpioSet (hDevice,18,0)){//PCTL2 OFF
			AddText(_T("PCTL2 OFF Failed\n"));
		}else{
			AddText(_T("PCTL2 OFF Success\n"));
		}
	}
}


void CUSB5744Dlg::OnBnClickedButton6()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(	hDevice !=  INVALID_HANDLE_VALUE){
		if(FALSE == libMchpUsbGpioSet (hDevice,19,1)){//PCTL3 ON
			AddText(_T("PCTL3 ON Failed\n"));
		}else{
			AddText(_T("PCTL3 ON Success\n"));
		}
	}
}


void CUSB5744Dlg::OnBnClickedButton7()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(	hDevice !=  INVALID_HANDLE_VALUE){
		if(FALSE == libMchpUsbGpioSet (hDevice,19,0)){//PCTL3 OFF
			AddText(_T("PCTL3 OFF Failed\n"));
		}else{
			AddText(_T("PCTL3 OFF Success\n"));
		}
	}
}


void CUSB5744Dlg::OnBnClickedButton8()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(	hDevice !=  INVALID_HANDLE_VALUE){
		if(FALSE == libMchpUsbGpioSet (hDevice,20,1)){//PCTL4 ON
			AddText(_T("PCTL4 ON Failed\n"));
		}else{
			AddText(_T("PCTL4 ON Success\n"));
		}
	}
}


void CUSB5744Dlg::OnBnClickedButton9()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(	hDevice !=  INVALID_HANDLE_VALUE){
		if(FALSE == libMchpUsbGpioSet (hDevice,20,0)){//PCTL4 OFF
			AddText(_T("PCTL4 OFF Failed\n"));
		}else{
			AddText(_T("PCTL4 OFF Success\n"));
		}
	}
}

void CUSB5744Dlg::OnBnClickedButton11()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	libMchpUsbClose(hDevice);
}
